﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Escacs
{
    class Program
    {
        static void Main(string[] args)
        {
            Taulell escacs = new Taulell();
            
            escacs["A",5]= new Fitxa("cavall");
            escacs["C2"]=new Fitxa("torre");

            Console.WriteLine(escacs["A5"].ToString());
            Console.WriteLine(escacs["C", 2].ToString());

            //Error aposta:
            escacs["I", 5] = new Fitxa("cavall");
            if (escacs["I5"] != null)
            {
                Console.WriteLine(escacs["I5"].ToString());
            }

            Console.ReadKey();
        }
    }
    
    class Fitxa
    {
        string nom;

        public Fitxa(string nom)
        {
            this.nom = nom;
        }
        
        public override string ToString()
        {
            return (nom);
        }
    }

    class Taulell
    {
        Fitxa[,] taulell = new Fitxa[8, 8];
        
        public Fitxa this[string fila, int columna]
        {
            get
            {
                return this.recollirFitxa(fila, columna);
            }
            set
            {
                this.agregarFitxa(fila, columna, value);
            }
        }
        
        public Fitxa this[string posicio]
        {
            get
            {
                string fila = posicio.Substring(0, 1); //posicio[0];
                int columna = Int16.Parse(posicio.Substring(1, 1)); //posicio[1];
                
                return this.recollirFitxa(fila, columna);
            }
            set
            {
                string fila = posicio.Substring(0, 1);
                int columna = Int16.Parse(posicio.Substring(1, 1));
                
                this.agregarFitxa(fila, columna, value);
            }
        }

        protected bool agregarFitxa(string fila, int columna, Fitxa fitxa)
        {
            bool totBe = false;

            char caracterFila = Char.Parse(fila.ToUpper());
            int f = caracterFila;
            f -= 'A';

            int c = columna - 1;
            
            if (f >= 0 && f < 8)
            {
                if (c >= 0 && c < 8)
                {
                    this.taulell[f, c] = fitxa;
                    totBe = true;
                }
            }

            if (!totBe) { Console.WriteLine("La posicio (" + fila + ", " + columna + ") no es valida o no concte cap peça"); }

            return totBe;
        }

        protected Fitxa recollirFitxa(string fila, int columna)
        {
            Fitxa fitxa = null;

            //int f = Int16.Parse(fila.ToUpper());
            //int f = (int) fila.ToUpper();
            //f -= 'A';
            //char caracterFila = Char.Parse(fila.ToUpper());
            //int f = Int16.Parse(caracterFila);
            //int f = (int) fila.ToUpper();
            //f -= 'A';
            char caracterFila = Char.Parse(fila.ToUpper());
            int f = caracterFila;
            f -= 'A';

            int c = columna - 1;

            if (f >= 0 && f < 8)
            {
                if (c >= 0 && c < 8)
                {
                    fitxa = this.taulell[f, c];
                }
            }

            if (fitxa == null) { Console.WriteLine("La posicio (" + fila + ", " + columna + ") no es valida o no concte cap peça"); }

            return fitxa;
        }
    }
}