﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using FormEsborrarSpace;

using FormMatriculacioSpace;

using BaseDatosNamespace;

namespace MainFormSpace
{
    public partial class MainForm : Form
    {
        static public BD baseDatos = null; //Objecte manegador de la base de dades.

        public MainForm()
        {
            InitializeComponent();
        }

        //Metode que s'executa al fer click en Sortir:
        private void sortirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Sortim del programa:
            System.Environment.Exit(0);
        }

        //Metode que s'executa al fer click en Esborrar Profes:
        private void esborrarProfesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Creem un formulari del tipus pertinent, "l'apadrinem" i el mostrem:
            FormEsborrar childForm = new FormEsborrar();
            childForm.MdiParent = this;
            childForm.Show();
        }

        //Metode que s'executa al fer click en Matriculacions:
        private void matriculacionsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Creem un formulari del tipus pertinent, "l'apadrinem" i el mostrem:
            FormMatriculacions childForm = new FormMatriculacions();
            childForm.MdiParent = this;
            childForm.Show();
        }

        //Metode que s'executa al visualitzar el form principal (quan s'inicia el programa):
        private void MainForm_Load(object sender, EventArgs e)
        {
            //Conecta a la base de dades:
            MainForm.baseDatos = new BD("root", "", "localhost", "iesbc");
            MainForm.baseDatos.conecta();
        }

        //Metode que s'executa al tancar el form principal (quan el programa termina):
        private void MainForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            //Desconecta de la base de dades:
            if (MainForm.baseDatos != null) { MainForm.baseDatos.desconecta(); }
        }
    }
}